/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_POLL
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_poll.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

static size_t last_poll_host_loc
#line 17 "bi_poll.m4"
;
static size_t last_poll_send_loc
#line 18 "bi_poll.m4"
;
static size_t last_poll_recv_loc
#line 19 "bi_poll.m4"
;
static size_t last_poll_greeting_loc
#line 20 "bi_poll.m4"
;
static size_t last_poll_helo_loc
#line 21 "bi_poll.m4"
;
static size_t cache_used_loc
#line 22 "bi_poll.m4"
;

void
set_last_poll_helo(eval_environ_t env, const char *text)
{
	
#line 27
{ size_t off;
#line 27
  if (text)
#line 27
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(text) + 1)), text);
#line 27
  else
#line 27
     off = 0;
#line 27
  *env_data_ref(env, last_poll_helo_loc) = (STKVAL) (off); }
#line 27
;
}

void
set_last_poll_greeting(eval_environ_t env, const char *text)
{
	
#line 33
{ size_t off;
#line 33
  if (text)
#line 33
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(text) + 1)), text);
#line 33
  else
#line 33
     off = 0;
#line 33
  *env_data_ref(env, last_poll_greeting_loc) = (STKVAL) (off); }
#line 33
;
}

void
set_last_poll_result(eval_environ_t env,
		     const char *host_addr,
		     const char *send, const char *recv)
{
	
#line 41
{ size_t off;
#line 41
  if (host_addr)
#line 41
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(host_addr) + 1)), host_addr);
#line 41
  else
#line 41
     off = 0;
#line 41
  *env_data_ref(env, last_poll_host_loc) = (STKVAL) (off); }
#line 41
;
	
#line 42
{ size_t off;
#line 42
  if (send)
#line 42
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(send) + 1)), send);
#line 42
  else
#line 42
     off = 0;
#line 42
  *env_data_ref(env, last_poll_send_loc) = (STKVAL) (off); }
#line 42
;
	
#line 43
{ size_t off;
#line 43
  if (recv)
#line 43
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(recv) + 1)), recv);
#line 43
  else
#line 43
     off = 0;
#line 43
  *env_data_ref(env, last_poll_recv_loc) = (STKVAL) (off); }
#line 43
;
}

void
set_cache_used(eval_environ_t env, int value)
{
	*env_data_ref(env, cache_used_loc) = (STKVAL) (value);
}


void
#line 53
bi_stdpoll(eval_environ_t env)
#line 53

#line 53 "bi_poll.m4"
{
#line 53
	
#line 53

#line 53

#line 53
char * email;
#line 53
        char * ehlo;
#line 53
        char * mailfrom;
#line 53
        
#line 53
get_string_arg(env, 0, &email);
#line 53
        get_string_arg(env, 1, &ehlo);
#line 53
        get_string_arg(env, 2, &mailfrom);
#line 53
        
#line 53

#line 53
        adjust_stack(env, 3);
#line 53

#line 53
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 53
		prog_trace(env, "stdpoll %s %s %s",email, ehlo, mailfrom);;
#line 53

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STANDARD POLL FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, ehlo, mailfrom);
	rc = method_standard(env, email, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
#line 63
			env_throw_bi(env, mf_status_to_exception(rc), "stdpoll", _("Unhandled exception %s"),mf_exception_str(rc))
;
			
	
#line 66
do {
#line 66
  push(env, (STKVAL) (rc));
#line 66
  return;
#line 66
} while (0);	
}
}

void
#line 70
bi_strictpoll(eval_environ_t env)
#line 70

#line 70 "bi_poll.m4"
{
#line 70
	
#line 70

#line 70

#line 70
char * host;
#line 70
        char * email;
#line 70
        char * ehlo;
#line 70
        char * mailfrom;
#line 70
        
#line 70
get_string_arg(env, 0, &host);
#line 70
        get_string_arg(env, 1, &email);
#line 70
        get_string_arg(env, 2, &ehlo);
#line 70
        get_string_arg(env, 3, &mailfrom);
#line 70
        
#line 70

#line 70
        adjust_stack(env, 4);
#line 70

#line 70
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 70
		prog_trace(env, "strictpoll %s %s %s %s",host, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = method_strict(env, email, host, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
#line 83
			env_throw_bi(env, mf_status_to_exception(rc), "strictpoll", _("Unhandled exception %s"),mf_exception_str(rc))
;
	
	
#line 86
do {
#line 86
  push(env, (STKVAL) (rc));
#line 86
  return;
#line 86
} while (0);	
}
}

void
#line 90
bi__pollhost(eval_environ_t env)
#line 90

#line 90 "bi_poll.m4"
{
#line 90
	
#line 90

#line 90

#line 90
char * host;
#line 90
        char * email;
#line 90
        char * ehlo;
#line 90
        char * mailfrom;
#line 90
        
#line 90
get_string_arg(env, 0, &host);
#line 90
        get_string_arg(env, 1, &email);
#line 90
        get_string_arg(env, 2, &ehlo);
#line 90
        get_string_arg(env, 3, &mailfrom);
#line 90
        
#line 90

#line 90
        adjust_stack(env, 4);
#line 90

#line 90
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 90
		prog_trace(env, "_pollhost %s %s %s %s",host, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLHOST %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = check_on_host(env, email, host, ehlo, mailfrom);

		if (!(mf_resolved(rc)))
#line 104
			env_throw_bi(env, mf_status_to_exception(rc), "_pollhost", _("Unhandled exception %s"),mf_exception_str(rc))
;
	
	
#line 107
do {
#line 107
  push(env, (STKVAL) (rc));
#line 107
  return;
#line 107
} while (0);	
}
}

void
#line 111
bi__pollmx(eval_environ_t env)
#line 111

#line 111 "bi_poll.m4"
{
#line 111
	
#line 111

#line 111

#line 111
char * domain;
#line 111
        char * email;
#line 111
        char * ehlo;
#line 111
        char * mailfrom;
#line 111
        
#line 111
get_string_arg(env, 0, &domain);
#line 111
        get_string_arg(env, 1, &email);
#line 111
        get_string_arg(env, 2, &ehlo);
#line 111
        get_string_arg(env, 3, &mailfrom);
#line 111
        
#line 111

#line 111
        adjust_stack(env, 4);
#line 111

#line 111
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 111
		prog_trace(env, "_pollmx %s %s %s %s",domain, email, ehlo, mailfrom);;

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLMX %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      domain, email, ehlo, mailfrom);

	rc = check_mx_records(env, email, domain, ehlo, mailfrom, NULL);

		if (!(mf_resolved(rc)))
#line 124
			env_throw_bi(env, mf_status_to_exception(rc), "_pollmx", _("Unhandled exception %s"),mf_exception_str(rc))
;

	
#line 127
do {
#line 127
  push(env, (STKVAL) (rc));
#line 127
  return;
#line 127
} while (0);	
}
}


#line 131
void
#line 131
poll_init_builtin()
#line 131
{
#line 131
	#line 17 "bi_poll.m4"
	last_poll_host_loc = builtin_variable_install("last_poll_host", dtype_string, VAR_VOLATILE)->off;
#line 18 "bi_poll.m4"
	last_poll_send_loc = builtin_variable_install("last_poll_send", dtype_string, VAR_VOLATILE)->off;
#line 19 "bi_poll.m4"
	last_poll_recv_loc = builtin_variable_install("last_poll_recv", dtype_string, VAR_VOLATILE)->off;
#line 20 "bi_poll.m4"
	last_poll_greeting_loc = builtin_variable_install("last_poll_greeting", dtype_string, VAR_VOLATILE)->off;
#line 21 "bi_poll.m4"
	last_poll_helo_loc = builtin_variable_install("last_poll_helo", dtype_string, VAR_VOLATILE)->off;
#line 22 "bi_poll.m4"
	cache_used_loc = builtin_variable_install("cache_used", dtype_number, VAR_VOLATILE)->off;
#line 53 "bi_poll.m4"
va_builtin_install_ex("stdpoll", bi_stdpoll, 0, dtype_number, 3, 0, 0|0, dtype_string, dtype_string, dtype_string);
#line 70 "bi_poll.m4"
va_builtin_install_ex("strictpoll", bi_strictpoll, 0, dtype_number, 4, 0, 0|0, dtype_string, dtype_string, dtype_string, dtype_string);
#line 90 "bi_poll.m4"
va_builtin_install_ex("_pollhost", bi__pollhost, 0, dtype_number, 4, 0, 0|0, dtype_string, dtype_string, dtype_string, dtype_string);
#line 111 "bi_poll.m4"
va_builtin_install_ex("_pollmx", bi__pollmx, 0, dtype_number, 4, 0, 0|0, dtype_string, dtype_string, dtype_string, dtype_string);

#line 131 "bi_poll.m4"
	
#line 131
}
#line 131

#line 625 "../mfd/snarf.m4"

#line 625

